!********************************************
! locate.f90
! Given an array table(1 .. n), and
! given a value x, returns the index such that 
! x is between table(j) and table(j+1)
! The search starts at the position jStart
!********************************************
integer function Locate(size, table, searchValue, jStart)
    implicit none
    integer, intent(in) :: size
    double precision, intent(in), dimension(size) :: table
    double precision, intent(in) :: searchValue
    integer, intent(inout) :: jStart
    integer :: k, klo, khi

    !********************************************
    ! Check to see if x is less than the minimum
    ! value in the table
    !********************************************
    if (searchValue .lt. table(1)) then
        Locate = 1
        return
    end if
  
    !***************************************
    ! Check to see if x is greater than the 
    ! maximum value in the table
    !***************************************
    if (searchValue .gt. table(size)) then
        Locate = size
        return
    end if

    klo = jStart
    khi = size
    do while((khi - klo) > 1)
        k = (khi + klo) / 2
        if (table(k) > searchValue) then
            khi = k
        else
            klo = k
        end if
    end do

    !*********************************
    ! klo and khi now bracket the 
    ! searchvalue
    !*********************************
    Locate = klo
    jStart = klo
end function Locate 
